package pack;

import java.util.Random;

public class Police {
    private int x, y;

    Police(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public void randomMove(int n, int m, PlayGround playGround) {
        boolean i, j, I, J;
        i = j = I = J = false;
        if (x != 0) i = true;
        if (x != n - 1) I = true;
        if (y != 0) j = true;
        if (y != m - 1) J = true;

        Random random = new Random();
        boolean confirm = false;
        int X = 0, Y = 0;

        do {
            switch (random.nextInt(8)) {
                case 0:
                    if (i && j) {
                        X = x - 1;
                        Y = y - 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 1:
                    if (i) {
                        X = x - 1;
                        Y = y;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 2:
                    if (i && J) {
                        X = x - 1;
                        Y = y + 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 3:
                    if (j) {
                        X = x;
                        Y = y - 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 4:
                    if (J) {
                        X = x;
                        Y = y + 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 5:
                    if (j && I) {
                        X = x + 1;
                        Y = y - 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 6:
                    if (I) {
                        X = x + 1;
                        Y = y;
                        confirm = playGround.isEmpty(X, Y);
                    }
                    break;

                case 7:
                    if (I && J) {
                        X = x + 1;
                        Y = y + 1;
                        confirm = playGround.isEmpty(X, Y);
                    }
            }
        } while (!confirm);

        playGround.changeSituation(x, y, X, Y, 1);
        x = X;
        y = Y;
    }

    public void targetedMove(int[][] thiefSituation, PlayGround playGround) {
        int X = thiefSituation[0][0], Y = thiefSituation[0][1];
        int[][] newSituation;

        if (x > X) {
            if (y > Y)         // down, right
                newSituation = confirmTargetMove(x, y, 1, playGround);
            else if (y < Y)  // down, left
                newSituation = confirmTargetMove(x, y, 3, playGround);
            else             // down
                newSituation = confirmTargetMove(x, y, 2, playGround);
        } else if (x < X) {
            if (y > Y)        // up, right
                newSituation = confirmTargetMove(x, y, 6, playGround);
            else if (y < Y)  // up, left
                newSituation = confirmTargetMove(x, y, 8, playGround);
            else             // up
                newSituation = confirmTargetMove(x, y, 7, playGround);
        } else {
            if (y < Y)         // left
                newSituation = confirmTargetMove(x, y, 5, playGround);
            else             // right
                newSituation = confirmTargetMove(x, y, 4, playGround);

        }

        playGround.changeSituation(x, y, newSituation[0][0], newSituation[0][1], 1);
        x = newSituation[0][0];
        y = newSituation[0][1];
    }

    private int[][] confirmTargetMove(int x, int y, int destination, PlayGround p) {
        int[][] newSituation = new int[1][2];
        Random r = new Random();

        switch (destination) {
            case 1:
                if (p.isEmpty(x - 1, y - 1)) {                 // go up & left
                    newSituation[0][0] = x - 1;
                    newSituation[0][1] = y - 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (p.isEmpty(x - 1, y)) {            // go up
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y;
                                return newSituation;
                            }
                        case 1:
                            if (p.isEmpty(x, y - 1)) {            // go left
                                newSituation[0][0] = x;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 2:
                if (p.isEmpty(x - 1, y)) {                        // go up
                    newSituation[0][0] = x - 1;
                    newSituation[0][1] = y;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (y != p.getNM()[0][1] - 1 && p.isEmpty(x - 1, y + 1)) {     // go up, right
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                        case 1:
                            if (y != 0 && p.isEmpty(x - 1, y - 1)) {     // go up, left
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 3:
                if (p.isEmpty(x - 1, y + 1)) {                 // go up & right
                    newSituation[0][0] = x - 1;
                    newSituation[0][1] = y + 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (p.isEmpty(x, y + 1)) {             // go right
                                newSituation[0][0] = x;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                        case 1:
                            if (p.isEmpty(x - 1, y)) {              // go up
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 4:
                if (p.isEmpty(x, y - 1)) {                        // go left
                    newSituation[0][0] = x;
                    newSituation[0][1] = y - 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (x != 0 && p.isEmpty(x - 1, y - 1)) {     // go up , left
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                        case 1:
                            if (x != p.getNM()[0][0]-1 && p.isEmpty(x + 1, y - 1)) {     // go down, left
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 5:
                if (p.isEmpty(x, y + 1)) {                        // go right
                    newSituation[0][0] = x;
                    newSituation[0][1] = y + 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (x != p.getNM()[0][0] -1&& p.isEmpty(x + 1, y + 1)) {     // go down, right
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                        case 1:
                            if (x != 0 && p.isEmpty(x - 1, y + 1)) {     // go up, right
                                newSituation[0][0] = x - 1;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 6:
                if (p.isEmpty(x + 1, y - 1)) {                 // go down & left
                    newSituation[0][0] = x + 1;
                    newSituation[0][1] = y - 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (p.isEmpty(x, y - 1)) {            // go left
                                newSituation[0][0] = x;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                        case 1:
                            if (p.isEmpty(x + 1, y)) {            // go down
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 7:
                if (p.isEmpty(x + 1, y)) {                        // go down
                    newSituation[0][0] = x + 1;
                    newSituation[0][1] = y;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (y != 0 && p.isEmpty(x + 1, y - 1)) {     // go down, left
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y - 1;
                                return newSituation;
                            }
                        case 1:
                            if (y != p.getNM()[0][1] -1&& p.isEmpty(x + 1, y + 1)) {     // go down, right
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

            case 8:
                if (p.isEmpty(x + 1, y + 1)) {          // go down, right
                    newSituation[0][0] = x + 1;
                    newSituation[0][1] = y + 1;
                    return newSituation;
                } else {
                    switch (r.nextInt(2)) {
                        case 0:
                            if (p.isEmpty(x + 1, y)) {            // go down
                                newSituation[0][0] = x + 1;
                                newSituation[0][1] = y;
                                return newSituation;
                            }
                        case 1:
                            if (p.isEmpty(x, y + 1)) {             // go right
                                newSituation[0][0] = x;
                                newSituation[0][1] = y + 1;
                                return newSituation;
                            }
                    }
                    newSituation[0][0] = x;                          // stay in previous situation
                    newSituation[0][1] = y;
                    return newSituation;
                }

        }
        return newSituation;
    }
}